// Michael J. Wilson
// Music 256a Fall 2010
// Homework #2

#include "UnitDelay.h"
#include "Utility.h"

UnitDelay::~UnitDelay()
{
    delete m_buffer;
}

UnitDelay::UnitDelay(size_t delay)
    : m_delay(delay),
      m_read_index(0)
{
    m_buffer = new std::vector<double>(delay, 0.0);
    m_loop_size = m_buffer->size();
    m_write_index = (m_loop_size - 1);
}

double UnitDelay::get_next_sample(double* input_sample)
{
    double result = 0.0;

    if (input_sample)
    {
        if (m_loop_size > 0)
        {
            (*m_buffer)[m_write_index] = *input_sample;
            result = (*m_buffer)[m_read_index];

            m_read_index++;
            m_write_index++;

            m_read_index %= m_loop_size;
            m_write_index %= m_loop_size;
        }
        else
        {
            result = *input_sample;
        }
    }

    return (result);
}
