// Michael J. Wilson
// Music 256a Fall 2010
// Homework #2

#ifndef __UNITDELAY_H__
#define __UNITDELAY_H__

#include "UnitGen.h"
#include <vector>

/// Basic sine wave
class UnitDelay : public UnitGen
{
public:
    /// Destructor
    virtual ~UnitDelay();

    /// Constructor
    UnitDelay(size_t delay = 0);

    /// Get the sample at the specified time and sample offset
    virtual double get_next_sample(double* input_sample = NULL);

protected:
    /// The number of samples to delay
    unsigned long m_delay;

    std::vector<double>* m_buffer;
    size_t m_read_index;
    size_t m_write_index;

    // Size of the loop, should always be less than or equal to the buffer size
    size_t m_loop_size;
};

#endif
