// Michael J. Wilson
// Music 256a Fall 2010
// Homework #2

#include "UnitDelayFeedback.h"
#include "Utility.h"

UnitDelayFeedback::~UnitDelayFeedback()
{
}

UnitDelayFeedback::UnitDelayFeedback(size_t delay, double attenuation)
    : UnitDelay(delay),
      m_attenuation(attenuation)
{
}

double UnitDelayFeedback::get_next_sample(double* input_sample)
{
    double result = 0.0;

    if (input_sample)
    {
        if (m_loop_size > 0)
        {
            result = (*m_buffer)[m_read_index];

            (*m_buffer)[m_write_index] = (*input_sample + result * m_attenuation);

            // TODO Maybe we should normalize this, but for now clip to [-1.0, 1.0]
            if ((*m_buffer)[m_write_index] > 1.0)
            {
                (*m_buffer)[m_write_index] = 1.0;
            }
            else if ((*m_buffer)[m_write_index] < -1.0)
            {
                (*m_buffer)[m_write_index] = -1.0;
            }

            m_read_index++;
            m_write_index++;

            m_read_index %= m_loop_size;
            m_write_index %= m_loop_size;
        }
        else
        {
            result = *input_sample;
        }
    }

    return (result);
}
