// Michael J. Wilson
// Music 256a Fall 2010
// Homework #2

#ifndef __UNITKARPLUSSTRONG_H__
#define __UNITKARPLUSSTRONG_H__

#include "UnitDelayFeedback.h"
#include <vector>

/// Basic Karplus Strong plucked string model
class UnitKarplusStrong : public UnitDelayFeedback
{
public:
    /// Destructor
    virtual ~UnitKarplusStrong();

    /// Constructor
    UnitKarplusStrong(double frequency, double attenuation = 0.99);

    /// Get the next sample to play
    virtual double get_next_sample(double* input_sample = NULL);

    /// Excite the instrument
    void play(double gain);

    /// Set the attenuation on the string
    void set_attenuation(double attenuation);

    /// Set the frequency of the string
    void set_frequency(double frequency);

protected:
    /// Last sample, for use in averaging
    double m_previous_output_sample;
};

#endif
