// Michael J. Wilson
// Music 256a Fall 2010
// Homework #2

#include "Utility.h"
#include <cassert>
#include <cmath>
#include <cstdlib>
#include <ctime>

// Static initializations
const double Utility::PI = std::atan(1.0)*4;
const double Utility::EPSILON = 0.0000001;
const unsigned int Utility::SAMPLE_RATE = 44100;
const unsigned int Utility::OUTPUT_CHANNELS = 2;
const std::string Utility::PROGRAM_NAME = "string-thing";

Utility* Utility::get_utility()
{
    static Utility* instance = new Utility();
    return instance;
}

Utility::Utility()
{
    // Seed random number generator
    std::srand(std::time(NULL));
}

Utility::~Utility()
{
}

double Utility::rand(double min, double max)
{
    return (min + ((max - min) * ((double)std::rand() / (double)RAND_MAX)));
}

double Utility::midi_to_frequency(int note)
{
    assert (note >=0);
    assert (note <=127);

    // Reference frequency is A440, note number 69
    const double fref=440;
    return (fref * std::pow(2,((double)note-69.0)/12.0));
}
